Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 #
      3 # Copyright (c) International Business Machines  Corp., 2005
      4 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      5 #
      6 # This library is free software; you can redistribute it and/or
      7 # modify it under the terms of the GNU Lesser General Public
      8 # License as published by the Free Software Foundation; either
      9 # version 2.1 of the License, or (at your option) any later version.
     10 #
     11 # This library is distributed in the hope that it will be useful,
     12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     14 # Lesser General Public License for more details.
     15 #
     16 # You should have received a copy of the GNU Lesser General Public
     17 # License along with this library; if not, write to the Free Software
     18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     19 #
     20 
     21 
     22 SETS_DEFAULTS="${TCID=test02} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST02***************"
     29 tst_resm TINFO "move: shared subtree to private parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test02 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" share dir
     44 	"${FS_BIND_ROOT}/bin/makedir" priv parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share1
     46 	"${FS_BIND_ROOT}/bin/makedir" share share2
     47 
     48 
     49 	mount --bind dir share1
     50 	mkdir dir/grandchild
     51 	mkdir parent2/child2
     52 	mount --move dir parent2/child2
     53 	mount --bind parent2 share2
     54 
     55 	mount --bind "$disk1" parent2/child2/grandchild
     56 	check parent2/child2/grandchild share1/grandchild
     57 	check -n dir/grandchild parent2/child2/grandchild
     58 	check -n share2/child2/grandchild parent2/child2/grandchild
     59 
     60 	mount --bind "$disk2" share1/grandchild/a
     61 
     62 	check parent2/child2/grandchild/a share1/grandchild/a
     63 
     64 	break
     65 done
     66 trap 'ERR=$? ; tst_resm TWARN "move/test02: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     67 if [ -n "${ERR_MSG}" ]; then
     68 	tst_resm TWARN "move/test02: ${ERR_MSG}"
     69 	ERR_MSG=""
     70 	result=$ERR
     71 fi
     72 trap '' ERR
     73 {
     74 	umount share1/grandchild/a
     75 	umount share1/grandchild/
     76 	umount parent2/child2
     77 	umount share1
     78 	umount share1
     79 	umount share2
     80 	umount share2
     81 	umount parent2
     82 
     83 	rm -rf dir parent* share*
     84 	cleanup
     85 } >& /dev/null
     86 if [ $result -ne 0 ]
     87 then
     88 	tst_resm TFAIL "move/test02: FAILED: move: shared subtree to private parent."
     89 	exit 1
     90 else
     91 	tst_resm TPASS "move/test02: PASSED"
     92 	exit 0
     93 fi
     94 tst_exit
     95